VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmDock 
   BorderStyle     =   4  'Fixed ToolWindow
   ClientHeight    =   780
   ClientLeft      =   5880
   ClientTop       =   3510
   ClientWidth     =   2940
   ControlBox      =   0   'False
   Icon            =   "frmDock.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   780
   ScaleWidth      =   2940
   ShowInTaskbar   =   0   'False
   Begin ComctlLib.Toolbar tbrToolbar 
      Height          =   630
      Left            =   0
      TabIndex        =   0
      Top             =   120
      Width           =   1335
      _ExtentX        =   2355
      _ExtentY        =   1111
      ButtonWidth     =   1032
      ButtonHeight    =   1005
      AllowCustomize  =   0   'False
      Appearance      =   1
      ImageList       =   "imgListLarge"
      _Version        =   327682
      BeginProperty Buttons {0713E452-850A-101B-AFC0-4210102A8DA7} 
         NumButtons      =   3
         BeginProperty Button1 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "Exit"
            Object.ToolTipText     =   "Exit"
            Object.Tag             =   ""
            ImageIndex      =   1
         EndProperty
         BeginProperty Button2 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "AutoHide"
            Object.ToolTipText     =   "Enable AutoHide"
            Object.Tag             =   ""
            ImageIndex      =   2
         EndProperty
         BeginProperty Button3 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "Fixed"
            Object.ToolTipText     =   "Disable Autohide"
            Object.Tag             =   ""
            ImageIndex      =   3
         EndProperty
      EndProperty
   End
   Begin VB.Timer tmrHide 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   2280
      Top             =   240
   End
   Begin ComctlLib.ImageList imgListLarge 
      Left            =   1560
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   32
      ImageHeight     =   32
      MaskColor       =   -2147483633
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   3
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmDock.frx":000C
            Key             =   "Exit"
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmDock.frx":01A6
            Key             =   "AutoHide"
         EndProperty
         BeginProperty ListImage3 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmDock.frx":0820
            Key             =   "Fixed"
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmDock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim lFormTopMouseDown  As Long
Dim lFormLeftMouseDown As Long

Private Sub Form_Load()
'
' Register a new appbar and specify its notification message.
'
With BarData
    .cbSize = Len(BarData)
    .hwnd = frmDock.hwnd
    .uCallbackMessage = WM_MOUSEMOVE
End With
'
' This timer is used to hide an autohide appbar after
' it is exposed.  Disable it until the appbar is exposed.
'
tmrHide.Enabled = False
End Sub
Private Sub Form_Unload(Cancel As Integer)
If Not gbEnd Then
    If Not fUnloadForm() Then
        Cancel = True
    End If
End If
End Sub
Private Sub tbrToolbar_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim lTop     As Long
Dim lLeft    As Long
Dim lRight   As Long
Dim lBottom  As Long
Dim lWidth   As Long
Dim lHeight  As Long

If Not gbAutoHide Then Exit Sub
'
' This event triggers when the mouse moves over an autohide
' appbar.  First determine if the appbar is hidden then,
' if it is, the location to move it to.  Once moved, enable
' the timer to hide it when the mouse moves off of it.
'
On Error GoTo tbrToolBarMouseMove
Select Case abPosition
    Case abDockedTop
        If frmDock.Top < 0 Then
            lWidth = glAppBarRight - glAppBarLeft
            Call SetWindowPos(BarData.hwnd, HWND_TOP, glAppBarLeft, 0, lWidth, glHeight, SWP_SHOWWINDOW)
            frmDock.tmrHide.Enabled = True
        End If

    Case abDockedBottom
        If (frmDock.Top \ glTwipsPerPixelY) + glHeight > glScreenHeight Then
            lTop = glScreenHeight - glHeight
            lWidth = glAppBarRight - glAppBarLeft
            Call SetWindowPos(BarData.hwnd, HWND_TOP, glAppBarLeft, lTop, lWidth, glHeight, SWP_SHOWWINDOW)
            frmDock.tmrHide.Enabled = True
        End If
    
    Case abDockedRight
        If (frmDock.Left \ glTwipsPerPixelX) + glWidth > glScreenWidth Then
            lLeft = glScreenWidth - glWidth
            lHeight = glAppBarBottom - glAppBarTop
            Call SetWindowPos(BarData.hwnd, HWND_TOP, lLeft, glAppBarTop, glWidth, lHeight, SWP_SHOWWINDOW)
            frmDock.tmrHide.Enabled = True
        End If
    
    Case abDockedLeft
        If frmDock.Left < 0 Then
            lHeight = glAppBarBottom - glAppBarTop
            Call SetWindowPos(BarData.hwnd, HWND_TOP, 0, glAppBarTop, glWidth, lHeight, SWP_SHOWWINDOW)
            frmDock.tmrHide.Enabled = True
        End If
End Select
Exit Sub

tbrToolBarMouseMove:
    Call pDisplayError("Error displaying the AutoHide appbar.")
End Sub
Private Sub tbrToolbar_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim lFormTopMouseUp  As Long
Dim lFormLeftMouseUp As Long
Dim lNewLeft         As Long
Dim lNewTop          As Long
'
' Reposition the appbar. (For more comments, see tbrMouseDown).
'
On Error GoTo tbrMouseUpError
'
' Get the cursor's current coordinates.
'
Call GetCursorPos(CursorLoc)
lFormTopMouseUp = CursorLoc.y
lFormLeftMouseUp = CursorLoc.x
'
' If it differs (by +/- 5 pixels) from when the user pressed a mouse
' button, move the appbar to the new position (See tbrMouseDown).
'
If (Abs(Abs(lFormTopMouseUp) - Abs(lFormTopMouseDown)) > 5) Or _
   (Abs(Abs(lFormLeftMouseUp) - Abs(lFormLeftMouseDown)) > 5) Then
    With lpwndpl.rcNormalPosition
        .Top = lFormTopMouseUp
        .Left = lFormLeftMouseUp
        .Right = lFormLeftMouseUp + (frmDock.Width / glTwipsPerPixelX)
        .Bottom = lFormTopMouseUp + (frmDock.Height / glTwipsPerPixelY)
        Call SetWindowPlacement(frmDock.hwnd, lpwndpl)
    End With
    '
    ' Reset the appbar's location.
    '
    lNewLeft = lFormLeftMouseUp * glTwipsPerPixelX
    lNewTop = lFormTopMouseUp * glTwipsPerPixelY
    Call pSetAppBarLocation("MOUSEUP", lNewLeft, lNewTop)
    '
    ' Re-size the appbar.
    '
    Call pSetAppBarDimensions(False)
End If
Exit Sub

tbrMouseUpError:
    Call pDisplayError("Error determining the cursor's position.")
End Sub

Private Sub tmrHide_Timer()
'
' This timer is enabled when the mouse moves over an AutoHide
' appbar and exposes it.  If the mouse is no longer over the
' appbar, hide it and disable this timer.
'
Dim lpPoint As POINTAPI

On Error GoTo abHideError
Call GetCursorPos(lpPoint)
With lpPoint
If .x < Left \ glTwipsPerPixelX Or _
   .x > (Left + Width) \ glTwipsPerPixelX Or _
   .y < Top \ glTwipsPerPixelY Or _
   .y > (Top + Height) \ glTwipsPerPixelY Then
   
    Select Case abPosition
        Case abDockedTop
            Call SetWindowPos(Me.hwnd, HWND_TOP, glAppBarLeft, 0 - glHeight, _
                 glAppBarRight - glAppBarLeft, glHeight + EXPOSURE, SWP_NOACTIVATE)
        Case abDockedBottom
            Call SetWindowPos(Me.hwnd, HWND_TOP, glAppBarLeft, glScreenHeight - EXPOSURE, _
                 glAppBarRight - glAppBarLeft, glHeight + EXPOSURE, SWP_NOACTIVATE)
        Case abDockedLeft
            Call SetWindowPos(Me.hwnd, HWND_TOP, 0 - glWidth, glAppBarTop, _
                 glWidth + EXPOSURE, glAppBarBottom - glAppBarTop, SWP_NOACTIVATE)
        Case abDockedRight
            Call SetWindowPos(Me.hwnd, HWND_TOP, glScreenWidth - EXPOSURE, glAppBarTop, _
                 glWidth, glAppBarBottom - glAppBarTop, SWP_NOACTIVATE)
    End Select
    tmrHide.Enabled = False
End If
End With
Exit Sub

abHideError:
    Call pDisplayError("Error hiding the AutoHide appbar.")
End Sub
Private Sub tbrToolbar_ButtonClick(ByVal Button As ComctlLib.Button)
Call ptbrButtonClick(Button.Index)
End Sub

Private Sub tbrToolbar_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'
' When the user wants to drag a docked appbar to a new location
' it is a bit tricky because the form does not expose a title
' bar.  Thus, the Mouse_Down and Mouse_Up events are used.
' Here (the mouse_down event) we capture the current top and
' left coordinates of the appbar.  In the Mouse_Up event we do
' the same.  If the two positions differ, the appbar is
' moved to the new location.
'
Call GetCursorPos(CursorLoc)
lFormTopMouseDown = CursorLoc.y
lFormLeftMouseDown = CursorLoc.x
End Sub

